<?php

require __DIR__ . "/../vendor/autoload.php";
require __DIR__ . "/../vendor/zeedhi/framework/bootstrap.php";
require __DIR__ . "/../vendor/teknisa/libraries/scripts/bootstrap.php";

$instanceManager = \Zeedhi\Framework\DependencyInjection\InstanceManager::getInstance();

$routes[] = __DIR__ . '/../vendor/teknisa/libraries/libRoutes.json';
$routes[] = __DIR__ . '/../config/routes.json';

$instanceManager->loadFromFile('../config/db.xml');
$instanceManager->loadFromFile('../config/general.xml');
$instanceManager->loadFromFile('../config/parameters.xml');
$instanceManager->loadFromFile('../config/environment.xml');

$container = $instanceManager->getContainer();

$instanceManager->loadFromFile('../config/di_maps/others.xml');
$instanceManager->loadFromFile('../config/di_maps/controllers.xml');
$instanceManager->loadFromFile('../config/di_maps/services.xml');
$instanceManager->loadFromFile('../config/di_maps/factories.xml');

$instanceManager->registerService('routeParser', new \Zeedhi\Framework\Routing\Parsers\JSONFormat($routes));
$instanceManager->compile();

use Doctrine\DBAL\Types\Type;

Type::overrideType(Type::DATE, 'OrganizationsManagement\Util\ORM\DateType');
Type::overrideType(Type::DATETIME, 'OrganizationsManagement\Util\ORM\DateTimeType');

$entity_manager = $instanceManager->getService('entityManager');
\Setforms2\Shared\Registry::store("EntityManager", $entity_manager);
\Setforms2\Shared\Registry::store("EntityManagerConnection", $entity_manager->getConnection());
