<?php


namespace OrganizationsManagement\Service;

use OrganizationsManagement\Util\InstanceProvider;
use Doctrine\ORM\EntityManager;


class Cliente
{
    private $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function findAllClientes($page, $pageSize)
    {
        $limit  = $page * $pageSize;
        $offset = ($page - 1) * $pageSize;
        return InstanceProvider::getRepository()->getCliente()->findAllClientes($limit, $offset);
    }

    public function findClientesPorOperador($cdOperador)
    {
        return InstanceProvider::getRepository()->getCliente()->findClientesPorOperador($cdOperador);
    }

    public function findRelacionarClientesComOperador($cdoperador)
    {
        return InstanceProvider::getRepository()->getCliente()->findRelacionarClientesComOperador($cdoperador);
    }

    public function saveRelacionarClientesComOperador($clientes, $cdoperador, $idtpoperclie, $nrpriopercli)
    {
        $operclieFactory = InstanceProvider::getFactory()->getOperclie();
        $environment     = InstanceProvider::getLibEnvironment();
        $nrorg    = $environment->getCurrentOrganizationId();
        $currentOperator = $environment->getCurrentUserId();
        $dtAtual = new \DateTime();
        try {
            foreach ($clientes as $cliente) {
                $operclie = $operclieFactory->create($cliente['CDCLIENTE'], $cdoperador, $idtpoperclie,
                    $nrpriopercli, $nrorg, $currentOperator, $dtAtual);
                $this->entityManager->persist($operclie);
            }
            $this->entityManager->flush();
        } catch(\Exception $e) {
            throw new \Exception($e->getMessage());
        }
    }

    public function deleteRelacionarClientesComOperador($clientes)
    {
        $operclieRepository = InstanceProvider::getRepository()->getOperclie();
        foreach ($clientes as $cliente) {
            /** @var \Teknisa\Model\Teknisa\Entities\Operclie $operclie */
            $operclie = $operclieRepository->findOneBy(array('cdcliente' => $cliente['CDCLIENTE'], 'cdoperador' => $cliente['CDOPERADOR']));
            $this->entityManager->remove($operclie);
        }
        $this->entityManager->flush();
    }
}