/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/* LIB (ALTERAR BANCO DE DADOS)                                               */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: 9702_LIBSTP_INSERTCOLUMNS                                            */
/*                                                                            */
/* Descrio:                                                                 */
/*    Insere as colunas de uma determinada tabela na tabela COLUNA           */
/*                                                                            */
/* Criao:                                                                   */
/*    18/08/2000 - Peterson Batista P. Silva                                  */
/*                                                                            */
/* Manutenes:                                                               */
/*   /  /   -                                                                 */
/*                                                                            */
/******************************************************************************/

/******************************************************************************/
/* @H:\SISTEMAS\DBA\SQL\ORACLE\9702_LIBSTP_INSERTCOLUMNS.SQL                  */
/******************************************************************************/

CREATE OR REPLACE PROCEDURE INSERTCOLUMNS
                     (P_NMTABELA  IN TABELA.NMTABELABD%TYPE)
IS

   V_PRIMARY INTEGER;
   V_EXIST INTEGER;
   V_TIPO VARCHAR2(1);

BEGIN

   DELETE FROM COLUNA
   WHERE
      (NMTABELABD = P_NMTABELA)  AND
      ((IDCRIADOCOL = 'S')    AND
       (NMTABELABD,NMCOLUNA) NOT IN
        (SELECT
            TABLE_NAME,
            COLUMN_NAME
         FROM
            USER_TAB_COLUMNS
         WHERE
            TABLE_NAME = P_NMTABELA));

   COMMIT;

   FOR C_COLUNA IN
      (SELECT
          TABLE_NAME,
          COLUMN_NAME,
          DATA_TYPE,
          DATA_LENGTH,
          NULLABLE,
          'S' AS IDCRIADO
       FROM
          USER_TAB_COLUMNS COL
       WHERE
          (UPPER(TABLE_NAME) = P_NMTABELA)) LOOP

       UPDATE COLUNA
       SET
          NRTAMANHOCOL = C_COLUNA.DATA_LENGTH,
          IDCOLUNANULL = C_COLUNA.NULLABLE
       WHERE
          (NMTABELABD = P_NMTABELA)            AND
          (NMCOLUNA = C_COLUNA.COLUMN_NAME);


       SELECT COUNT(*) INTO V_PRIMARY
       FROM
          USER_CONS_COLUMNS COCOL
       WHERE
          (TABLE_NAME  = P_NMTABELA)            AND
          (COLUMN_NAME = C_COLUNA.COLUMN_NAME) AND
          (CONSTRAINT_NAME  = 'PK_'||P_NMTABELA);

       SELECT COUNT(*) INTO V_EXIST
       FROM
          COLUNA
       WHERE
          NMTABELABD = C_COLUNA.TABLE_NAME AND
          NMCOLUNA   = C_COLUNA.COLUMN_NAME;

       IF C_COLUNA.DATA_TYPE = 'DATE' THEN
          V_TIPO := 'D';
       ELSIF C_COLUNA.DATA_TYPE = 'NUMBER' THEN
          V_TIPO := 'N';
       ELSE
          V_TIPO := 'C';
       END IF;

       IF V_EXIST = 0 THEN
          IF V_PRIMARY = 0 THEN
             INSERT INTO COLUNA (NMTABELABD            , NMCOLUNA,
                                  IDTIPOCOLUNA          , NRTAMANHOCOL,
                                  IDCOLUNANULL          , IDCRIADOCOL,
                                  IDPRIMARY)
             VALUES              (C_COLUNA.TABLE_NAME, C_COLUNA.COLUMN_NAME,
                                  V_TIPO             , C_COLUNA.DATA_LENGTH,
                                  C_COLUNA.NULLABLE  , C_COLUNA.IDCRIADO,
                                  '');
          ELSE
             INSERT INTO COLUNA (NMTABELABD            , NMCOLUNA,
                                  IDTIPOCOLUNA          , NRTAMANHOCOL,
                                  IDCOLUNANULL          , IDCRIADOCOL,
                                  IDPRIMARY)
             VALUES              (C_COLUNA.TABLE_NAME, C_COLUNA.COLUMN_NAME,
                                  V_TIPO             , C_COLUNA.DATA_LENGTH,
                                  C_COLUNA.NULLABLE  , C_COLUNA.IDCRIADO,
                                  'S');
          END IF;
       END IF;
   END LOOP;
END;
/

